import { Injector } from '@angular/core';
import { Observable } from 'rxjs';
import { FirebaseAuth } from './firebase-auth.service';
import { FirebaseDatabase } from './firebase-database.service';
import { NativeFirebaseApp } from './native-firebase';
export interface FirebaseAppConfig {
    name?: string;
    options: {
        apiKey: string;
        authDomain?: string;
        databaseURL?: string;
        storageBucket?: string;
        messagingSenderId?: string;
    };
}
export declare class FirebaseApp {
    config: FirebaseAppConfig;
    private injector;
    nativeApp: NativeFirebaseApp;
    private _auth;
    private _database;
    constructor(config: FirebaseAppConfig, injector: Injector);
    delete(): Observable<void>;
    auth(): FirebaseAuth;
    database<T>(): FirebaseDatabase<T>;
}
