import { ModuleWithProviders, Injector, InjectionToken } from '@angular/core';
import { FirebaseAuth } from './firebase-auth.service';
import { FirebaseDatabase } from './firebase-database.service';
import { FirebaseAppConfig, FirebaseApp } from './firebase-app.service';
export declare function invokeLazy(): boolean;
export declare function setLazyInvocation(lazy: boolean): void;
export declare function appFactory(injector: Injector, config: FirebaseAppConfig): FirebaseApp;
export declare function authFactory(app: FirebaseApp): FirebaseAuth;
export declare function databaseFactory(app: FirebaseApp): FirebaseDatabase<{}>;
export declare class FirebaseModule {
    /**
     * Provides a firebase app which will be be injected for `FirebaseApp`. Further the app's
     * `FirebaseAuth` and `FirebaseDatabase` can be injected in the same way.
     * @param config Firebase app config.
     */
    static primaryApp(config: FirebaseAppConfig): ModuleWithProviders;
    /**
     * Provides a `FirebaseApp` which will be injected for {@param token}.
     *
     * @param config Firebase app config.
     */
    static secondaryApp(token: InjectionToken<FirebaseApp>, config: FirebaseAppConfig): {
        ngModule: typeof FirebaseModule;
        providers: ({
            provide: string;
            useValue: FirebaseAppConfig;
        } | {
            provide: InjectionToken<FirebaseApp>;
            useFactory: (injector: Injector, config: FirebaseAppConfig) => FirebaseApp;
            deps: (string | typeof Injector)[];
        })[];
    };
}
