var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule, Injector } from '@angular/core';
import { FirebaseAuth } from './firebase-auth.service';
import { FirebaseDatabase } from './firebase-database.service';
import { FirebaseApp } from './firebase-app.service';
/** @internal */
var lazyInvocation = true;
export function invokeLazy() {
    return lazyInvocation;
}
export function setLazyInvocation(lazy) {
    lazyInvocation = lazy;
}
export function appFactory(injector, config) {
    return new FirebaseApp(config, injector);
}
export function authFactory(app) {
    return app.auth();
}
export function databaseFactory(app) {
    return app.database();
}
var FirebaseModule = FirebaseModule_1 = (function () {
    function FirebaseModule() {
    }
    /**
     * Provides a firebase app which will be be injected for `FirebaseApp`. Further the app's
     * `FirebaseAuth` and `FirebaseDatabase` can be injected in the same way.
     * @param config Firebase app config.
     */
    FirebaseModule.primaryApp = function (config) {
        return {
            ngModule: FirebaseModule_1,
            providers: [
                {
                    provide: 'firebase-config-' + config.options.apiKey,
                    useValue: config
                },
                {
                    provide: FirebaseApp,
                    useFactory: appFactory,
                    deps: [Injector, 'firebase-config-' + config.options.apiKey]
                },
                {
                    provide: FirebaseAuth,
                    useFactory: authFactory,
                    deps: [FirebaseApp]
                },
                {
                    provide: FirebaseDatabase,
                    useFactory: databaseFactory,
                    deps: [FirebaseApp]
                }
            ]
        };
    };
    /**
     * Provides a `FirebaseApp` which will be injected for {@param token}.
     *
     * @param config Firebase app config.
     */
    FirebaseModule.secondaryApp = function (token, config) {
        return {
            ngModule: FirebaseModule_1,
            providers: [
                {
                    provide: 'firebase-config-' + config.options.apiKey,
                    useValue: config
                },
                {
                    provide: token,
                    useFactory: appFactory,
                    deps: [Injector, 'firebase-config-' + config.options.apiKey,]
                }
            ]
        };
    };
    return FirebaseModule;
}());
FirebaseModule = FirebaseModule_1 = __decorate([
    NgModule({})
], FirebaseModule);
export { FirebaseModule };
var FirebaseModule_1;
//# sourceMappingURL=firebase.module.js.map